-- name: [CS] Sugar Queen Character Pack
-- description: A set of original characters from the Sugar Queen Franchise, fully voiced and playable!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_BEA_MODEL = smlua_model_util_get_id("bea_geo")
local E_MODEL_BEA2_MODEL = smlua_model_util_get_id("beag_geo")
local E_MODEL_BEA3_MODEL = smlua_model_util_get_id("bear_geo")
local E_MODEL_BEA4_MODEL = smlua_model_util_get_id("beab_geo")
local E_MODEL_BEAOLD_MODEL = smlua_model_util_get_id("bealegacy_geo")
local E_MODEL_BEASOLOVOX_MODEL = smlua_model_util_get_id("beacraft_geo")
local E_MODEL_BEASPRITE_MODEL = smlua_model_util_get_id("beavoxel_geo")
local E_MODEL_CLOWN_MODEL = smlua_model_util_get_id("clown_geo")
local E_MODEL_CLOWN2_MODEL = smlua_model_util_get_id("clownr_geo")
local E_MODEL_CLOWN3_MODEL = smlua_model_util_get_id("clowng_geo")
local E_MODEL_CLOWN4_MODEL = smlua_model_util_get_id("clownb_geo")
local E_MODEL_CLOWNSPOOKY_MODEL = smlua_model_util_get_id("clownspooky_geo")
local E_MODEL_CLOWNMARIO_MODEL = smlua_model_util_get_id("clownmario_geo")
local E_MODEL_FAKECLOWN_MODEL = smlua_model_util_get_id("clownfake_geo")
local E_MODEL_DILBO_MODEL = smlua_model_util_get_id("dilbo_geo")
local E_MODEL_DILBO2_MODEL = smlua_model_util_get_id("dilbop_geo")
local E_MODEL_DILBO3_MODEL = smlua_model_util_get_id("dilbob_geo")
local E_MODEL_DILBO4_MODEL = smlua_model_util_get_id("dilbom_geo")
local E_MODEL_DILBOPAPER_MODEL = smlua_model_util_get_id("dilbopaperhat_geo")
local E_MODEL_DILBOVIKING_MODEL = smlua_model_util_get_id("dilboviking_geo")
local E_MODEL_DILBOLINK_MODEL = smlua_model_util_get_id("dilbolink_geo")
local E_MODEL_DILBOSOLOVOX_MODEL = smlua_model_util_get_id("dilbocraft_geo")
local E_MODEL_HORNETTE_MODEL = smlua_model_util_get_id("hornette_geo")
local E_MODEL_HORNETTEWEEGEE_MODEL = smlua_model_util_get_id("hornette2_geo")
local E_MODEL_HORNETTEGWONAM_MODEL = smlua_model_util_get_id("hornette3_geo")
local E_MODEL_HORNETTELEAN_MODEL = smlua_model_util_get_id("hornette4_geo")
local E_MODEL_HORNETTECURSED_MODEL = smlua_model_util_get_id("hornettecursed_geo")
local E_MODEL_HORNETTEOG_MODEL = smlua_model_util_get_id("hornetteog_geo")


local TEX_BEA_ICON = get_texture_info("bea-icon")
local TEX_CLOWN_ICON = get_texture_info("clown-icon")
local TEX_DILBO_ICON = get_texture_info("dilbo-icon")
local TEX_HORNETTE_ICON = get_texture_info("hornette-icon")



local TEXT_MOD_NAME = "Sugar Queen Char Pack"

local VOICETABLE_BEA = {
    [CHAR_SOUND_ATTACKED] = 'pain_bea.ogg',
    [CHAR_SOUND_SNORING1] = 'snore1_bea.ogg',
    [CHAR_SOUND_SNORING2] = 'snore2_bea.ogg',
    [CHAR_SOUND_SNORING3] = 'snore2_bea.ogg',
	[CHAR_SOUND_COUGHING1] = 'cough.ogg',
    [CHAR_SOUND_COUGHING2] = 'cough.ogg',
    [CHAR_SOUND_COUGHING3] = 'cough.ogg',
	[CHAR_SOUND_EEUH] = 'pullingselfup.ogg',
    [CHAR_SOUND_HRMM] = 'pull_bea.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'tired_bea.ogg',
    [CHAR_SOUND_PANTING] = 'pant_bea.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'pant_bea.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'hereicome_bea.ogg',
    [CHAR_SOUND_DOH] = 'doh_bea.ogg',
	[CHAR_SOUND_UH] = 'uh_bea.ogg',	
	[CHAR_SOUND_UH2] = 'uh_bea.ogg',	
    [CHAR_SOUND_DROWNING] = 'drown_bea.ogg',
    [CHAR_SOUND_DYING] = 'die.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'nnah_bea.ogg',
    [CHAR_SOUND_HAHA] = 'haha_bea.ogg',
    [CHAR_SOUND_HAHA_2] = 'haha_bea.ogg',
    [CHAR_SOUND_HERE_WE_GO] = {'doingood_bea.ogg', 'tooeasy_bea.ogg', 'yeahbaby_bea.ogg'},
    [CHAR_SOUND_HOOHOO] = 'hoohoo_bea.ogg',
    [CHAR_SOUND_MAMA_MIA] = {'dammit_bea.ogg', 'okaythen_bea.ogg'},
    [CHAR_SOUND_OKEY_DOKEY] = 'hereicome_bea.ogg',
    [CHAR_SOUND_ON_FIRE] = 'burn_bea.ogg',
    [CHAR_SOUND_OOOF] = 'oof_bea.ogg',
    [CHAR_SOUND_OOOF2] = 'oof_bea.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'hoo_bea.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'wah_bea.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'yah_bea.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'tata_bea.ogg', 'buzzoff_bea.ogg', 'byebye_bea.ogg', 'byebyegayasskoopabitch.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'boing_bea.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'falling_bea.ogg',
    [CHAR_SOUND_WAH2] = 'tya_bea.ogg',
    [CHAR_SOUND_WHOA] = 'woah_bea.ogg',
    [CHAR_SOUND_YAHOO] = 'yahoo_bea.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'ohyeah_bea.ogg', 'rockandroll_bea.ogg', 'yahoo_bea.ogg', 'boing_bea.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'tya_bea.ogg', 'nnah_bea.ogg', 'hup_bea.ogg', 'woo_bea.ogg','wah_bea.ogg'},
    [CHAR_SOUND_YAWNING] = 'yawn_bea.ogg',
}

local VOICETABLE_CLOWN = {
    [CHAR_SOUND_ATTACKED] = 'pain2_clown.ogg',
	[CHAR_SOUND_COUGHING1] = 'honk2.ogg',
    [CHAR_SOUND_COUGHING2] = 'honk2.ogg',
    [CHAR_SOUND_COUGHING3] = 'honk2.ogg',
	[CHAR_SOUND_EEUH] = 'honk8.ogg',
    [CHAR_SOUND_HRMM] = 'honk6.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'honkC.ogg',
	[CHAR_SOUND_UH] = 'wubble.ogg',	
	[CHAR_SOUND_UH2] = 'bwoomp.ogg',	
    [CHAR_SOUND_PANTING] = 'honk7.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'pain1_clown.ogg',
    [CHAR_SOUND_DOH] = 'loudslap.ogg',
    [CHAR_SOUND_DROWNING] = 'pain1_clown.ogg',
    [CHAR_SOUND_DYING] = 'dissapointedcrowd.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'honk9.ogg',
    [CHAR_SOUND_HAHA] = 'honk1.ogg',
    [CHAR_SOUND_HAHA_2] = 'honk1.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'tadaa.ogg',
    [CHAR_SOUND_HOOHOO] = 'honk4.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'death_clown.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'honk8.ogg',
    [CHAR_SOUND_ON_FIRE] = 'pain2_clown.ogg',
    [CHAR_SOUND_OOOF] = 'bawong.ogg',
    [CHAR_SOUND_OOOF2] = 'bawong.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'honk3.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'honk2.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'honk2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'honk9.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'cartoonbouncy.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'dissapointedcrowd.ogg',
    [CHAR_SOUND_WAH2] = 'bwoomp.ogg',
    [CHAR_SOUND_WHOA] = 'bwoomp.ogg',
    [CHAR_SOUND_YAHOO] = 'honk5.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'honk5.ogg', 'honk9.ogg', 'honkA.ogg', 'honkB.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'honk2.ogg', 'honk3.ogg'},
    [CHAR_SOUND_YAWNING] = 'honk7.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'herewego_clown.ogg'
}

local VOICETABLE_DILBO = {
    [CHAR_SOUND_ATTACKED] = 'hurt.ogg',
	[CHAR_SOUND_COUGHING1] = 'bump.ogg',
    [CHAR_SOUND_COUGHING2] = 'bump.ogg',
    [CHAR_SOUND_COUGHING3] = 'bump.ogg',
	[CHAR_SOUND_EEUH] = 'dilbo6.ogg',
    [CHAR_SOUND_HRMM] = 'dilbo7.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'dilbotired.ogg',
	[CHAR_SOUND_UH] = 'bump.ogg',	
	[CHAR_SOUND_UH2] = 'bump.ogg',	
    [CHAR_SOUND_SNORING1] = 'dilbosnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'dilbosnore2.ogg',
    [CHAR_SOUND_SNORING3] = 'dilbosnore2.ogg',
    [CHAR_SOUND_PANTING] = 'dilbosnore2.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'drown.ogg',
    [CHAR_SOUND_DOH] = 'bump.ogg',
    [CHAR_SOUND_DROWNING] = 'drown.ogg',
    [CHAR_SOUND_DYING] = {'dilbo5.ogg', 'dilbo5.ogg', 'dilbo5.ogg', 'dilbo5.ogg', 'dilbosecretdeath1.ogg'},
    [CHAR_SOUND_GROUND_POUND_WAH] = {'spike.ogg', 'heart.ogg'},
    [CHAR_SOUND_HAHA] = 'nut.ogg',
    [CHAR_SOUND_HAHA_2] = 'timer.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'win.ogg',
    [CHAR_SOUND_HOOHOO] = 'throw.ogg',
    [CHAR_SOUND_MAMA_MIA] = {'dilbo4.ogg', 'dilbo4.ogg', 'dilbo4.ogg', 'dilbo4.ogg', 'dilbosecretdeath2.ogg'},
    [CHAR_SOUND_OKEY_DOKEY] = 'heart.ogg',
    [CHAR_SOUND_ON_FIRE] = 'death.ogg',
    [CHAR_SOUND_OOOF] = 'bump.ogg',
    [CHAR_SOUND_OOOF2] = 'throw.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'dilbo2.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'throw.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'womp.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'dilbosolong.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = {'bounce.ogg', 'bounce.ogg', 'bounce.ogg', 'bounce.ogg', 'dilbojingle.ogg'},
    [CHAR_SOUND_WAAAOOOW] = 'death.ogg',
    [CHAR_SOUND_WAH2] = 'throw.ogg',
    [CHAR_SOUND_WHOA] = 'dilbo9.ogg',
    [CHAR_SOUND_YAHOO] = 'bounce.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'bounce.ogg', 'dilbo3.ogg', 'dilbo7.ogg', 'dilbo8.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = 'jump.ogg',
    [CHAR_SOUND_YAWNING] = 'dilboyawn.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'dilboletsago.ogg'
}

local VOICETABLE_HORNETTE = {
    [CHAR_SOUND_ATTACKED] = 'pain_hornette.ogg',
    [CHAR_SOUND_SNORING1] = 'snore1_hornette.ogg',
    [CHAR_SOUND_SNORING2] = 'snore2_hornette.ogg',
    [CHAR_SOUND_SNORING3] = 'snore2_hornette.ogg',
	[CHAR_SOUND_COUGHING1] = 'nyeh_hornette.ogg',
    [CHAR_SOUND_COUGHING2] = 'nyeh_hornette.ogg',
    [CHAR_SOUND_COUGHING3] = 'nyeh_hornette.ogg',
	[CHAR_SOUND_EEUH] = 'effort_hornette.ogg',
    [CHAR_SOUND_HRMM] = 'lift_hornette.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'trsh_hornette.ogg',
    [CHAR_SOUND_PANTING] = 'pant_hornette.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'pant_hornette.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'hereicome_hornette.ogg',
    [CHAR_SOUND_DOH] = 'doh_hornette.ogg',
	[CHAR_SOUND_UH] = 'trsh_hornette.ogg',	
	[CHAR_SOUND_UH2] = 'trsh_hornette.ogg',	
    [CHAR_SOUND_DROWNING] = 'drown_hornette.ogg',
    [CHAR_SOUND_DYING] = {'moan_hornette.ogg', 'endswell_hornette.ogg'},
    [CHAR_SOUND_GROUND_POUND_WAH] = 'nyeh_hornette.ogg',
    [CHAR_SOUND_HAHA] = 'haha_hornette.ogg',
    [CHAR_SOUND_HAHA_2] = 'haha_hornette.ogg',
    [CHAR_SOUND_HERE_WE_GO] = {'doinggood_hornette.ogg', 'tooeasy_hornette.ogg', 'yeahbaby_hornette.ogg'},
    [CHAR_SOUND_HOOHOO] = 'hoohoo_hornette.ogg',
    [CHAR_SOUND_MAMA_MIA] = {'dammit_hornette.ogg', 'okaythen_hornette.ogg'},
    [CHAR_SOUND_OKEY_DOKEY] = 'hereicome_hornette.ogg',
    [CHAR_SOUND_ON_FIRE] = 'burn_hornette.ogg',
    [CHAR_SOUND_OOOF] = 'oof_hornette.ogg',
    [CHAR_SOUND_OOOF2] = 'oof_hornette.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'hoo_hornette.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'wah_hornette.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'yuh_hornette.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'tata_hornette.ogg', 'buzzoff_hornette.ogg', 'byebye_hornette.ogg', 'vista_hornette.ogg', 'solong_hornette.ogg'},
    [CHAR_SOUND_TWIRL_BOUNCE] = 'boing_hornette.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'ohno_hornette.ogg',
    [CHAR_SOUND_WAH2] = 'wah_hornette.ogg',
    [CHAR_SOUND_WHOA] = 'woah_hornette.ogg',
    [CHAR_SOUND_YAHOO] = 'yahoo_hornette.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'ohyeah_hornette.ogg', 'rockandroll_hornette.ogg', 'yahoo_hornette.ogg', 'boing_hornette.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'woo_hornette.ogg', 'tyah_hornette.ogg', 'trsh_hornette.ogg', 'hup_hornette.ogg','huh_hornette.ogg'},
    [CHAR_SOUND_YAWNING] = 'moan_hornette.ogg',
}

local VOICETABLE_2017 = {
    [CHAR_SOUND_ATTACKED] = '2017bumped.ogg',
	[CHAR_SOUND_COUGHING1] = '2017swing.ogg',
    [CHAR_SOUND_COUGHING2] = '2017swing.ogg',
    [CHAR_SOUND_COUGHING3] = '2017swing.ogg',
	[CHAR_SOUND_UH2] = '2017swing.ogg',	
    [CHAR_SOUND_PANTING] = '2017swing.ogg',
    [CHAR_SOUND_PANTING_COLD] = '2017swing.ogg',
    [CHAR_SOUND_DOH] = '2017break.ogg',
	[CHAR_SOUND_EEUH] = '2017pickup.ogg',
    [CHAR_SOUND_HRMM] = '2017pickup.ogg',
    [CHAR_SOUND_DROWNING] = '2017die.ogg',
    [CHAR_SOUND_DYING] = '2017die.ogg',
    [CHAR_SOUND_HAHA] = '2017coin.ogg',
    [CHAR_SOUND_HAHA_2] = '2017coin.ogg',
    [CHAR_SOUND_HOOHOO] = '2017jumping.ogg',
    [CHAR_SOUND_HERE_WE_GO] = '2017pickup.ogg',
    [CHAR_SOUND_MAMA_MIA] = '2017bumped.ogg',
    [CHAR_SOUND_ON_FIRE] = '2017die.ogg',
    [CHAR_SOUND_OOOF] = '2017bumped.ogg',
    [CHAR_SOUND_OOOF2] = '2017bumped.ogg',
    [CHAR_SOUND_UH] = '2017bumped.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = '2017bumped.ogg',
    [CHAR_SOUND_WAAAOOOW] = '2017die.ogg',
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = '2017bloon.ogg',
	[CHAR_SOUND_YAHOO] = '2017jumping.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = '2017jumping.ogg',
    [CHAR_SOUND_PUNCH_HOO] = '2017swing.ogg',
    [CHAR_SOUND_PUNCH_WAH] = '2017swing.ogg',
    [CHAR_SOUND_PUNCH_YAH] = '2017swing.ogg',
}

local VOICETABLE_FAKECLOWN = {
	[CHAR_SOUND_UH] = 'wubble.ogg',	
	[CHAR_SOUND_UH2] = 'bwoomp.ogg',
    [CHAR_SOUND_DROWNING] = 'theaudiencehatedthat.ogg',
    [CHAR_SOUND_DYING] = 'theaudiencehatedthat.ogg',	
    [CHAR_SOUND_DOH] = 'loudslap.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'tadaa.ogg',
    [CHAR_SOUND_OOOF] = 'bawong.ogg',
    [CHAR_SOUND_OOOF2] = 'bawong.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'cartoonbouncy.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'theaudiencehatedthat.ogg',
    [CHAR_SOUND_WAH2] = 'bwoomp.ogg',
    [CHAR_SOUND_WHOA] = 'bwoomp.ogg',
}


if _G.charSelectExists then
    CT_BEA = _G.charSelect.character_add("Bea", {"A rotund treasure hunter with a massive sweet tooth", "She's only here for the cake", "", "", "Use D-pad L/R to Switch Skins"}, "ChaoThix", {r = 255, g = 217, b = 0}, E_MODEL_BEA_MODEL, CT_WARIO, TEX_BEA_ICON)
	CT_CLOWN = _G.charSelect.character_add("Miss Clown", {"Bea's loyal sidekick and voice(?) of reason", "The nicest gal you will ever meet", "", "", "Use D-pad L/R to Switch Skins"}, "ChaoThix", {r = 143, g = 30, b = 230}, E_MODEL_CLOWN_MODEL, CT_LUIGI, TEX_CLOWN_ICON, 1.4)
	CT_DILBO = _G.charSelect.character_add("Dilbo", {"A little creature lost in a strange world", "Can you him escape...?", "", "", "Use D-pad L/R to Switch Skins"}, "ChaoThix", {r = 45, g = 114, b = 143}, E_MODEL_DILBO_MODEL, CT_TOAD, TEX_DILBO_ICON, 0.9)
	CT_HORNETTE = _G.charSelect.character_add("Hornette", {"Bea's mischevious doppleganger", "She causes nothing but mayhem", "", "", "Use D-pad L/R to Switch Skins"}, "ChaoThix", {r = 164, g = 168, b = 50}, E_MODEL_HORNETTE_MODEL, CT_WALUIGI, TEX_HORNETTE_ICON)
	
    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_BEA_MODEL, VOICETABLE_BEA)
	_G.charSelect.character_add_voice(E_MODEL_BEA2_MODEL, VOICETABLE_BEA)
	_G.charSelect.character_add_voice(E_MODEL_BEA3_MODEL, VOICETABLE_BEA)
	_G.charSelect.character_add_voice(E_MODEL_BEA4_MODEL, VOICETABLE_BEA)
	_G.charSelect.character_add_voice(E_MODEL_BEAOLD_MODEL, VOICETABLE_BEA)
	_G.charSelect.character_add_voice(E_MODEL_BEASOLOVOX_MODEL, VOICETABLE_BEA)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_BEA then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_BEA then return _G.charSelect.voice.snore(m) end
    end)
    _G.charSelect.character_add_voice(E_MODEL_CLOWN_MODEL, VOICETABLE_CLOWN)
	_G.charSelect.character_add_voice(E_MODEL_CLOWN2_MODEL, VOICETABLE_CLOWN)
	_G.charSelect.character_add_voice(E_MODEL_CLOWN3_MODEL, VOICETABLE_CLOWN)
	_G.charSelect.character_add_voice(E_MODEL_CLOWN4_MODEL, VOICETABLE_CLOWN)
	_G.charSelect.character_add_voice(E_MODEL_CLOWNMARIO_MODEL, VOICETABLE_CLOWN)
	_G.charSelect.character_add_voice(E_MODEL_CLOWNSPOOKY_MODEL, VOICETABLE_CLOWN)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CLOWN then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_CLOWN then return _G.charSelect.voice.snore(m) end
    end)
    _G.charSelect.character_add_voice(E_MODEL_DILBO_MODEL, VOICETABLE_DILBO)
	_G.charSelect.character_add_voice(E_MODEL_DILBO2_MODEL, VOICETABLE_DILBO)
	_G.charSelect.character_add_voice(E_MODEL_DILBO3_MODEL, VOICETABLE_DILBO)
	_G.charSelect.character_add_voice(E_MODEL_DILBO4_MODEL, VOICETABLE_DILBO)
	_G.charSelect.character_add_voice(E_MODEL_DILBOPAPER_MODEL, VOICETABLE_DILBO)
	_G.charSelect.character_add_voice(E_MODEL_DILBOVIKING_MODEL, VOICETABLE_DILBO)
	_G.charSelect.character_add_voice(E_MODEL_DILBOLINK_MODEL, VOICETABLE_DILBO)
	_G.charSelect.character_add_voice(E_MODEL_DILBOSOLOVOX_MODEL, VOICETABLE_DILBO)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_DILBO then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_DILBO then return _G.charSelect.voice.snore(m) end
    end)
    _G.charSelect.character_add_voice(E_MODEL_HORNETTE_MODEL, VOICETABLE_HORNETTE)
    _G.charSelect.character_add_voice(E_MODEL_HORNETTELEAN_MODEL, VOICETABLE_HORNETTE)
    _G.charSelect.character_add_voice(E_MODEL_HORNETTEGWONAM_MODEL, VOICETABLE_HORNETTE)
    _G.charSelect.character_add_voice(E_MODEL_HORNETTEWEEGEE_MODEL, VOICETABLE_HORNETTE)
	_G.charSelect.character_add_voice(E_MODEL_HORNETTECURSED_MODEL, VOICETABLE_HORNETTE)
	_G.charSelect.character_add_voice(E_MODEL_HORNETTEOG_MODEL, VOICETABLE_HORNETTE)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_HORNETTE then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_HORNETTE then return _G.charSelect.voice.snore(m) end
    end)
	_G.charSelect.character_add_voice(E_MODEL_BEASPRITE_MODEL, VOICETABLE_2017)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_2017 then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_2017 then return _G.charSelect.voice.snore(m) end
    end)
	_G.charSelect.character_add_voice(E_MODEL_FAKECLOWN_MODEL, VOICETABLE_FAKECLOWN)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_FAKECLOWN then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_FAKECLOWN then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end

beaAlt = 1
local beaAltTable = {
    {outfitName = "Default", outfitModel = E_MODEL_BEA_MODEL},
	{outfitName = "Green Outfit", outfitModel = E_MODEL_BEA2_MODEL},
	{outfitName = "Red Outfit", outfitModel = E_MODEL_BEA3_MODEL},
	{outfitName = "Purple Outfit", outfitModel = E_MODEL_BEA4_MODEL},
	{outfitName = "Debut Duds", outfitModel = E_MODEL_BEAOLD_MODEL},
	{outfitName = "Minecraft", outfitModel = E_MODEL_BEASOLOVOX_MODEL},
	{outfitName = "2017 Styled ", outfitModel = E_MODEL_BEASPRITE_MODEL},
}

clownAlt = 1
local clownAltTable = {
    {outfitName = "Default", outfitModel = E_MODEL_CLOWN_MODEL},
	{outfitName = "Red Outfit", outfitModel = E_MODEL_CLOWN2_MODEL},
	{outfitName = "Green Outfit", outfitModel = E_MODEL_CLOWN3_MODEL},
	{outfitName = "Blue Outfit", outfitModel = E_MODEL_CLOWN4_MODEL},
	{outfitName = "Pipe Cleaner", outfitModel = E_MODEL_CLOWNMARIO_MODEL},
	{outfitName = "Spooky Spaghetti", outfitModel = E_MODEL_CLOWNSPOOKY_MODEL},
	{outfitName = "Fake Clown", outfitModel = E_MODEL_FAKECLOWN_MODEL},
}

local dilboAlt = 1
local dilboAltTable = {
    {outfitName = "Default", outfitModel = E_MODEL_DILBO_MODEL},
	{outfitName = "Purple", outfitModel = E_MODEL_DILBO2_MODEL},
	{outfitName = "Charcoal", outfitModel = E_MODEL_DILBO3_MODEL},
	{outfitName = "Minty", outfitModel = E_MODEL_DILBO4_MODEL},
    {outfitName = "Paper Hat", outfitModel = E_MODEL_DILBOPAPER_MODEL},
	{outfitName = "Viking Helmet", outfitModel = E_MODEL_DILBOVIKING_MODEL},
	{outfitName = "Hero's Cap", outfitModel = E_MODEL_DILBOLINK_MODEL},
}

local hornetteAlt = 1
local hornetteAltTable = {
    {outfitName = "Default", outfitModel = E_MODEL_HORNETTE_MODEL},
	{outfitName = "Green Outfit", outfitModel = E_MODEL_HORNETTEWEEGEE_MODEL},
	{outfitName = "Red Outfit", outfitModel = E_MODEL_HORNETTEGWONAM_MODEL},
    {outfitName = "Purple Outfit", outfitModel = E_MODEL_HORNETTELEAN_MODEL},	
    {outfitName = "Way Better", outfitModel = E_MODEL_HORNETTEOG_MODEL},	
	{outfitName = "Cursed", outfitModel = E_MODEL_HORNETTECURSED_MODEL},
}

--[[
for i = 1, beaAltTable do
    _G.charSelect.character_add_voice(beaAltTable[i].outfitModel, VOICETABLE_WALUIGI)
end
]]

local function update_bea_edit(intAdd)
    beaAlt = beaAlt + intAdd
    if beaAlt > #beaAltTable then beaAlt = 1 end
    if beaAlt < 1 then beaAlt = #beaAltTable end
    _G.charSelect.character_edit(CT_BEA, nil, {"A rotund treasure hunter with a massive sweet tooth", "She's only here for the cake", "", "< Skin: "..beaAltTable[beaAlt].outfitName.." >", "Use D-pad L/R to Switch Skins"}, nil, nil, beaAltTable[beaAlt].outfitModel, CT_WARIO, TEX_CUSTOM_ICON, 1)
end

local function update_clown_edit(intAdd)
    clownAlt = clownAlt + intAdd
    if clownAlt > #clownAltTable then clownAlt = 1 end
    if clownAlt < 1 then clownAlt = #clownAltTable end
    _G.charSelect.character_edit(CT_CLOWN, nil, {"Bea's loyal sidekick and voice(?) of reason", "The nicest gal you will ever meet", "", "< Skin: "..clownAltTable[clownAlt].outfitName.." >", "Use D-pad L/R to Switch Skins"}, nil, nil, clownAltTable[clownAlt].outfitModel, CT_LUIGI, TEX_CUSTOM_ICON, 1.4)
end

local function update_dilbo_edit(intAdd)
    dilboAlt = dilboAlt + intAdd
    if dilboAlt > #dilboAltTable then dilboAlt = 1 end
    if dilboAlt < 1 then dilboAlt = #dilboAltTable end
    _G.charSelect.character_edit(CT_DILBO, nil, {"A little creature lost in a strange world", "Can you him escape...?", "", "< Skin: "..dilboAltTable[dilboAlt].outfitName.." >", "Use D-pad L/R to Switch Skins"}, nil, nil, dilboAltTable[dilboAlt].outfitModel, CT_TOAD, TEX_CUSTOM_ICON, 0.9)
end

local function update_hornette_edit(intAdd)
    hornetteAlt = hornetteAlt + intAdd
    if hornetteAlt > #hornetteAltTable then hornetteAlt = 1 end
    if hornetteAlt < 1 then hornetteAlt = #hornetteAltTable end
    _G.charSelect.character_edit(CT_HORNETTE, nil, {"Bea's mischevious doppleganger", "She causes nothing but mayhem", "", "< Skin: "..hornetteAltTable[hornetteAlt].outfitName.." >", "Use D-pad L/R to Switch Skins"}, nil, nil, hornetteAltTable[hornetteAlt].outfitModel, CT_WALUIGI, TEX_CUSTOM_ICON, 1)
end

local function mario_update(m)
    if m.playerIndex ~= 0 then return end
    if _G.charSelect.is_menu_open() then
        if _G.charSelect.character_get_current_number() == CT_BEA then
            if (_G.charSelect.controller.buttonPressed & R_JPAD) ~= 0 then
                update_bea_edit(1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
            if (_G.charSelect.controller.buttonPressed & L_JPAD) ~= 0 then
                update_bea_edit(-1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
        end
    end
	if _G.charSelect.is_menu_open() then
        if _G.charSelect.character_get_current_number() == CT_CLOWN then
            if (_G.charSelect.controller.buttonPressed & R_JPAD) ~= 0 then
                update_clown_edit(1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
            if (_G.charSelect.controller.buttonPressed & L_JPAD) ~= 0 then
                update_clown_edit(-1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
        end
    end
	if _G.charSelect.is_menu_open() then
        if _G.charSelect.character_get_current_number() == CT_DILBO then
            if (_G.charSelect.controller.buttonPressed & R_JPAD) ~= 0 then
                update_dilbo_edit(1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
            if (_G.charSelect.controller.buttonPressed & L_JPAD) ~= 0 then
                update_dilbo_edit(-1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
        end
    end
	if _G.charSelect.is_menu_open() then
        if _G.charSelect.character_get_current_number() == CT_HORNETTE then
            if (_G.charSelect.controller.buttonPressed & R_JPAD) ~= 0 then
                update_hornette_edit(1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
            if (_G.charSelect.controller.buttonPressed & L_JPAD) ~= 0 then
                update_hornette_edit(-1)
				play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
            end
        end
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)